package main

import (
	"codeberg.org/vlbeaudoin/voki/v3"
	"git.agecem.com/agecem/agecem-org/models"
)

type APIResponse struct {
	voki.MessageResponse
	statusCode int
	Error      string
}

func (R APIResponse) StatusCode() int {
	return R.statusCode
}

func (R *APIResponse) SetStatusCode(code int) {
	R.statusCode = code
}

type V1BucketsGET struct {
	APIResponse
	Data struct {
		Buckets map[string]string
	}
}

type V1BucketGET struct {
	APIResponse
	Data struct {
		Keys []string
	}
}

type DataDocument struct {
	Key  string
	Size int64
}

type V1DocumentsPOST struct {
	APIResponse
	Data struct {
		Bucket    string
		Documents []DataDocument
	}
}

// Deprecated: Use V1DocumentsPOST instead
type V1DocumentPOST struct {
	APIResponse
	Data struct {
		Bucket string
		DataDocument
	}
}

type V1DocumentDELETE struct {
	APIResponse
}

type V1DocumentKeyPUT struct {
	APIResponse
	Data struct {
		Bucket string
		Key    string
	}
}

type V1SeedPOST struct {
	APIResponse
	Data struct {
		Buckets []string
	}
}

type V1SpecGET struct {
	APIResponse
	Data struct {
		Spec string
	}
}

type HandleAdminDocumentsUploadResponse struct {
	APIResponse
	Data struct {
		Buckets []models.Bucket
	}
}

type HandleDocumentationResponse struct {
	APIResponse
	Data struct {
		Buckets []models.Bucket
	}
}

type UploadDocumentAPIResponse struct {
	APIResponse
	Data UploadDocumentResponseData
}

type UploadDocumentResponseData struct {
	Bucket string
	Object string
	Size   float64
}
